#include "sim900a.h"
#include "usart1.h"
#include "delay.h"
#include "stdio.h"
#include "string.h"
#include "24l01.h"
#include "usart.h"

u8 callnum[20]={0};
u8 txmsg[140];
//sim900a,յӦ
//str:ڴӦ
//ֵ:0,ûеõڴӦ
//    ,ڴӦλ(strλ)
u8* SIM900A_check_cmd(char *str)
{
	char *strx=0;
	if(USART1_RX_STA&0X8000)		//յһ
	{ 
		USART1_RX_BUF[USART1_RX_STA&0X7FFF]=0;//ӽ
		strx=strstr((const char*)USART1_RX_BUF,(const char*)str);
	} 
	return (u8*)strx;

}
//sim900a
//cmd:͵ַ(Ҫӻس),cmd<0XFFʱ,(緢0X1A),ڵʱַ.
//ack:ڴӦ,Ϊ,ʾҪȴӦ
//waittime:ȴʱ(λ:10ms)
//ֵ:0,ͳɹ(õڴӦ)
//       1,ʧ
u8 SIM900A_send_cmd(u8 *cmd,char *ack,u16 waittime)
{
	u8 res=0; 
	USART1_RX_STA=0;
	if((u32)cmd<=0XFF)
	{	   
		USART1->TDR=(u32)cmd;
	}else printf("%s\r\n",cmd);//

	if(ack&&waittime)		//ҪȴӦ
	{
		while(--waittime)	//ȴʱ
		{
			delay_ms(10);
			if(USART1_RX_STA&0X8000)//յڴӦ
			{
				
				if(SIM900A_check_cmd(ack))break;//õЧ 
				USART1_RX_STA=0;
			} 
		}
		if(waittime==0)res=1; 
	}
	return res;
} 

void SIM900A_sms_read_test()                                //յһϢΪokһHOW ARE YOU ,͸ź
{ 
	u8 *p2,*p1;			
	if(USART1_RX_STA&0x8000)
	{			
		USART1_RX_BUF[USART1_RX_STA&0X7FFF]='\0';
		if((u8*)strstr((const char*)(USART1_RX_BUF),"CMTI:")!=0)
		{	
			p1=(u8*)strstr((const char*)(USART1_RX_BUF),",");
			sprintf((char*)p2,"AT+CMGR=%s",p1+1);
			if(SIM900A_send_cmd(p2,"000000",600)==0)
			{
				if((u8*)strstr((const char*)(USART1_RX_BUF),"1")!=0)
				{					
						if((u8*)strstr((const char*)(USART1_RX_BUF),"OPENTHEDOOR")!=0)
						{
							 USART2_printf("յOPENTHEDOOR");
							 NRF24L01_TX_Mode(1);
							 if(NRF24L01_TxPacket("kaimen")==0x20);
							 if(NRF24L01_TxPacket("kaimen")==0x20);
						}
				}
				if((u8*)strstr((const char*)(USART1_RX_BUF),"3")!=0)
				{
						if((u8*)strstr((const char*)(USART1_RX_BUF),"IR_ON")!=0)
						{
							 NRF24L01_TX_Mode(3);
							 if(NRF24L01_TxPacket("IR_ON")==0x20);
						}
						if((u8*)strstr((const char*)(USART1_RX_BUF),"IR_OFF")!=0)
						{
							 NRF24L01_TX_Mode(3);
							 if(NRF24L01_TxPacket("IR_OFF")==0x20);
						}
						if((u8*)strstr((const char*)(USART1_RX_BUF),"IR_IGNORE")!=0)
						{
							 NRF24L01_TX_Mode(3);
							 if(NRF24L01_TxPacket("IR_IGNORE")==0x20);
						}
				}
				if((u8*)strstr((const char*)(USART1_RX_BUF),"4")!=0)
				{
						if((u8*)strstr((const char*)(USART1_RX_BUF),"OPEN")!=0)
						{
							 NRF24L01_TX_Mode(4);
							 if(NRF24L01_TxPacket("OPEN")==0x20);
						}
						if((u8*)strstr((const char*)(USART1_RX_BUF),"CLOSE")!=0)
						{
							 NRF24L01_TX_Mode(4);
							 if(NRF24L01_TxPacket("CLOSE")==0x20);
						}
						if((u8*)strstr((const char*)(USART1_RX_BUF),"HALF")!=0)
						{
							 NRF24L01_TX_Mode(4);
							 if(NRF24L01_TxPacket("HALF")==0x20);
						}
						
				}
				NRF24L01_RxPacket();
				strcat((char*)txmsg,(char*)tmp_buf2);
				strcat((char*)txmsg," Curtain State:");
				strcat((char*)txmsg,(char*)tmp_buf4);
				USART2_printf("%s",txmsg);
				callnumber("sim900a test");
				USART1_RX_STA=0;
			}	
			USART1_RX_STA=0;
		}
		else 
		{
			 USART1_RX_STA=0;			
		}

	}	
}
void SIM900A_phone_call_test()                                              //绰ԣյָĵ绰ҶϣزԷ
{
  	while(1)
	{		
		if(USART1_RX_STA&0x8000)
		{
					
			USART1_RX_BUF[USART1_RX_STA&0X7FFF]=0;
			if((strstr((const char*)(USART1_RX_BUF),"15731118089"))==0)
			{
				
				USART1_RX_STA=0;				
			}
			else 
			{	
				
				SIM900A_send_cmd( "ATH","ATH",200);
				delay_ms(8000);
				SIM900A_send_cmd("ATD15731118089;", "ATD15731118089",200);
				delay_ms(3000);
				USART1_RX_STA=0;																	
			}			
		}	
	}	  
}
void SIM900A_Init()
{


	if((SIM900A_send_cmd("AT","OK",100))==0)
	{	
		USART1_RX_STA=0;		
	}
	if((SIM900A_send_cmd("AT+CLIP=1","OK",100))==0);       //ʾܣյʱ
	{
		USART1_RX_STA=0;
	}
	if((SIM900A_send_cmd("AT+CNMI=2,1","OK",100))==0);		 //ϢʾյϢռδʱ
	{
		USART1_RX_STA=0;
	}
	if((SIM900A_send_cmd("AT+CMGF=1","OK",100))==0);     //ΪıģʽAT+CMGF=1 ıAT+CMGF=2 PDUģʽ
	{
		USART1_RX_STA=0;
	}
	if((SIM900A_send_cmd("AT+CSCS=\"GSM\"","OK",100))==0); //ʹӢĶ
	{
		USART1_RX_STA=0;
	}
}
/**********************************************************
**   :  callnumber
** :  ȡŷ˵ֻ룬ط
** :  u8* text
** : 
***********************************************************/
void callnumber(u8* text)
{
	u8 *p,i,number;	
	p=(u8*)strstr((const char*)(USART1_RX_BUF),"1");
	for(i=0;i<20;i++)
	{
		if((*p>='0')&&(*p<='9'))
		{
      number=*p;
			callnum[i]=number;
      p++;
		}
		else 
		{	
			//callnum[i]='\0';
			break;
		}
	}
   sprintf((char*)p,"AT+CMGS=\"%s\"",callnum);
   if(SIM900A_send_cmd(p,">",100)==0)
   {
		 USART2_printf("jinlaile");
     printf("%s",p);
		 USART_SendData(USART1, 'A');
		 USART_SendData(USART1, 'B');
		 delay_ms(2000);
      if(SIM900A_send_cmd((u8*)0X1A,"CMGS",1000)==0)
			{
				USART2_printf("");
			}
   }
   USART1_RX_STA=0;

}
